Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions

# SceneGraphReducer Class Reference

An interface for simplifying ("flattening") scene graphs by eliminating unneeded nodes and collapsing out unneeded state changes and transforms. More...

List of all members.

## Public Types
enum | AttribTypes { TTTransform = 1, TTColor = 2, TTColorScale = 4, TTTexMatrix = 8, TTClipPlane = 16, TTCullFace = 32, TTApplyTextureColor = 64, TTOther = 128 }
enum | CollectVertexData { CVDName = 1, CVDModel = 2, CVDTransform = 4, CVDAvoidDynamic = 8, CVDOneNodeOnly = 16, CVDFormat = 32, CVDUsageHint = 64, CVDAnimationType = 128 }
enum | CombineSiblings { CSGeomNode = 1, CSWithinRadius = 2, CSOther = 4, CSRecurse = 8 }
enum | MakeNonindexed { MNCompositeOnly = 1, MNAvoidAnimated = 2, MNAvoidDynamic = 4 }
## Public Member Functions
| SceneGraphReducer (GraphicsStateGuardianBase gsg)
| SceneGraphReducer ()
| applyAttribs (PandaNode node, AccumulatedAttribs const attribs, int attrib_types, GeomTransformer transformer)
| This flavor of apply_attribs() can be called recursively from within another flatten process (e.g.
| applyAttribs (PandaNode node, int attrib_types)
| Walks the scene graph, accumulating attribs of the indicated types, applying them to the vertices, and removing them from the scene graph.
| applyAttribs (PandaNode node)
| Walks the scene graph, accumulating attribs of the indicated types, applying them to the vertices, and removing them from the scene graph.
bool | checkLiveFlatten (PandaNode node)
| In a non-release build, returns false if the node is correctly not in a live scene graph.
| clearGsg ()
| Specifies that no particular GraphicsStateGuardian will be used to guide the optimization.
int | collectVertexData (PandaNode root, int collect_bits)
| Collects all different GeomVertexData blocks that have compatible formats at this node and below into a single, unified block (or at least multiple larger blocks).
int | collectVertexData (PandaNode root)
| Collects all different GeomVertexData blocks that have compatible formats at this node and below into a single, unified block (or at least multiple larger blocks).
| decompose (PandaNode root)
| Calls decompose() on every GeomNode at this level and below.
int | flatten (PandaNode root, int combine_siblings_bits)
| Simplifies the graph by removing unnecessary nodes and nodes.
float | getCombineRadius ()
| Returns the radius that is used in conjunction with CS_within_radius.
GraphicsStateGuardianBase | getGsg ()
| Returns the particular GraphicsStateGuardian that this object will attempt to optimize to.
int | makeCompatibleFormat (PandaNode root)
| Walks through the tree at this node and below and unifies the GeomVertexFormat for any GeomVertexData objects that are found, so that all eligible vdatas (according to collect_bits; see collect_vertex_data) will share the same vertex format.
int | makeCompatibleFormat (PandaNode root, int collect_bits)
| Walks through the tree at this node and below and unifies the GeomVertexFormat for any GeomVertexData objects that are found, so that all eligible vdatas (according to collect_bits; see collect_vertex_data) will share the same vertex format.
int | makeCompatibleState (PandaNode root)
| Searches for GeomNodes that contain multiple Geoms that differ only in their ColorAttribs.
int | makeNonindexed (PandaNode root)
| Converts indexed geometry to nonindexed geometry at the indicated node and below, by duplicating vertices where necessary.
int | makeNonindexed (PandaNode root, int nonindexed_bits)
| Converts indexed geometry to nonindexed geometry at the indicated node and below, by duplicating vertices where necessary.
| premunge (PandaNode root, RenderState const initial_state)
| Walks the scene graph rooted at this node and below, and uses the indicated GSG to premunge every Geom found to optimize it for eventual rendering on the indicated GSG.
int | removeColumn (PandaNode root, InternalName const column)
| Removes the indicated data column from any GeomVertexDatas found at the indicated root and below.
| removeUnusedVertices (PandaNode root)
| Removes any vertices in GeomVertexDatas that are no longer used at this level and below.
| setCombineRadius (float combine_radius)
| Specifies the radius that is used in conjunction with CS_within_radius to decide whether a subgraph's siblings should be combined into a single node or not.
| setGsg (GraphicsStateGuardianBase gsg)
| Specifies the particular GraphicsStateGuardian that this object will attempt to optimize to.
| unify (PandaNode root, bool preserve_order)
| Calls unify() on every GeomNode at this level and below.

## Detailed Description

An interface for simplifying ("flattening") scene graphs by eliminating unneeded nodes and collapsing out unneeded state changes and transforms.

This class is designed so that it may be inherited from and specialized, if needed, to fine-tune the flattening behavior, but normally the default behavior is sufficient.

## Member Enumeration Documentation

enum AttribTypes

Enumerator:

  TTTransform |
  TTColor |
  TTColorScale |
  TTTexMatrix |
  TTClipPlane |
  TTCullFace |
  TTApplyTextureColor |
  TTOther |

enum CollectVertexData

Enumerator:

  CVDName |
  CVDModel |
  CVDTransform |
  CVDAvoidDynamic |
  CVDOneNodeOnly |
  CVDFormat |
  CVDUsageHint |
  CVDAnimationType |

enum CombineSiblings

Enumerator:

  CSGeomNode |
  CSWithinRadius |
  CSOther |
  CSRecurse |

enum MakeNonindexed

Enumerator:

  MNCompositeOnly |
  MNAvoidAnimated |
  MNAvoidDynamic |

## Constructor & Destructor Documentation

SceneGraphReducer | ( | GraphicsStateGuardianBase | gsg | ) |

SceneGraphReducer | ( |  | ) |

## Member Function Documentation

applyAttribs | ( | PandaNode | node,
|  | AccumulatedAttribs const | attribs,
|  | int | attrib_types,
|  | GeomTransformer | transformer
| ) |  |

This flavor of apply_attribs() can be called recursively from within another flatten process (e.g.

from PandaNode.apply_attribs_to_vertices()). The parameters were presumably received from a parent SceneGraphReducer object.

applyAttribs | ( | PandaNode | node | ) |

Walks the scene graph, accumulating attribs of the indicated types, applying them to the vertices, and removing them from the scene graph.

This has a performance optimization benefit in itself, but is especially useful to pave the way for a call to flatten() and greatly improve the effectiveness of the flattening operation.

Multiply instanced geometry is duplicated before the attribs are applied.

Of course, this operation does make certain dynamic operations impossible.

applyAttribs | ( | PandaNode | node,
|  | int | attrib_types
| ) |  |

Walks the scene graph, accumulating attribs of the indicated types, applying them to the vertices, and removing them from the scene graph.

This has a performance optimization benefit in itself, but is especially useful to pave the way for a call to flatten() and greatly improve the effectiveness of the flattening operation.

Multiply instanced geometry is duplicated before the attribs are applied.

Of course, this operation does make certain dynamic operations impossible.

bool checkLiveFlatten | ( | PandaNode | node | ) |

In a non-release build, returns false if the node is correctly not in a live scene graph.

(Calling flatten on a node that is part of a live scene graph, for instance, a node somewhere under render, can cause problems in a multithreaded environment.)

If allow_live_flatten is true, or in a release build, this always returns true.

clearGsg | ( |  | ) |

Specifies that no particular GraphicsStateGuardian will be used to guide the optimization.

The SceneGraphReducer will instead use config variables such as max-collect-vertices and max-collect-indices.

int collectVertexData | ( | PandaNode | root | ) |

Collects all different GeomVertexData blocks that have compatible formats at this node and below into a single, unified block (or at least multiple larger blocks).

This is intended to reduce rendering overhead incurred by switching vertex buffers. It can also make a subsequent call to unify() much more effective than it would have been otherwise.

The set of bits passed in collect_bits indicates which properties are used to differentiate GeomVertexData blocks. If it is 0, then more blocks will be combined together than if it is nonzero.

int collectVertexData | ( | PandaNode | root,
|  | int | collect_bits
| ) |  |

Collects all different GeomVertexData blocks that have compatible formats at this node and below into a single, unified block (or at least multiple larger blocks).

This is intended to reduce rendering overhead incurred by switching vertex buffers. It can also make a subsequent call to unify() much more effective than it would have been otherwise.

The set of bits passed in collect_bits indicates which properties are used to differentiate GeomVertexData blocks. If it is 0, then more blocks will be combined together than if it is nonzero.

decompose | ( | PandaNode | root | ) |

Calls decompose() on every GeomNode at this level and below.

There is usually no reason to call this explicitly, since unify() will do this anyway if it needs to be done. However, calling it ahead of time can make that future call to unify() run a little bit faster.

This operation has no effect if the config variable preserve-triangle-strips has been set true.

int flatten | ( | PandaNode | root,
|  | int | combine_siblings_bits
| ) |  |

Simplifies the graph by removing unnecessary nodes and nodes.

In general, a node (and its parent node) is a candidate for removal if the node has no siblings and the node has no special properties.

If combine_siblings_bits is nonzero, some sibling nodes (according to the bits set in combine_siblings_bits) may also be collapsed into a single node. This will further reduce scene graph complexity, sometimes substantially, at the cost of reduced spatial separation.

Returns the number of nodes removed from the graph.

float getCombineRadius | ( |  | ) |

Returns the radius that is used in conjunction with CS_within_radius.

See set_combine_radius().

GraphicsStateGuardianBase getGsg | ( |  | ) |

Returns the particular GraphicsStateGuardian that this object will attempt to optimize to.

See set_gsg().

int makeCompatibleFormat | ( | PandaNode | root | ) |

Walks through the tree at this node and below and unifies the GeomVertexFormat for any GeomVertexData objects that are found, so that all eligible vdatas (according to collect_bits; see collect_vertex_data) will share the same vertex format.

This will add unused columns where necessary to match formats. It can result in suboptimal performance if used needlessly.

There is usually no reason to call this explicitly, since collect_vertex_data() will do this anyway if it has not been done already. However, calling it ahead of time can make that future call to collect_vertex_data() run a little bit faster.

The return value is the number of vertex datas modified.

int makeCompatibleFormat | ( | PandaNode | root,
|  | int | collect_bits
| ) |  |

Walks through the tree at this node and below and unifies the GeomVertexFormat for any GeomVertexData objects that are found, so that all eligible vdatas (according to collect_bits; see collect_vertex_data) will share the same vertex format.

This will add unused columns where necessary to match formats. It can result in suboptimal performance if used needlessly.

There is usually no reason to call this explicitly, since collect_vertex_data() will do this anyway if it has not been done already. However, calling it ahead of time can make that future call to collect_vertex_data() run a little bit faster.

The return value is the number of vertex datas modified.

int makeCompatibleState | ( | PandaNode | root | ) |

Searches for GeomNodes that contain multiple Geoms that differ only in their ColorAttribs.

If such a GeomNode is found, then all the colors are pushed down into the vertices. This makes it feasible for the geoms to be unified later.

int makeNonindexed | ( | PandaNode | root,
|  | int | nonindexed_bits
| ) |  |

Converts indexed geometry to nonindexed geometry at the indicated node and below, by duplicating vertices where necessary.

The parameter nonindexed_bits is a union of bits defined in SceneGraphReducer.MakeNonindexed, which specifes which types of geometry to avoid making nonindexed.

int makeNonindexed | ( | PandaNode | root | ) |

Converts indexed geometry to nonindexed geometry at the indicated node and below, by duplicating vertices where necessary.

The parameter nonindexed_bits is a union of bits defined in SceneGraphReducer.MakeNonindexed, which specifes which types of geometry to avoid making nonindexed.

premunge | ( | PandaNode | root,
|  | RenderState const | initial_state
| ) |  |

Walks the scene graph rooted at this node and below, and uses the indicated GSG to premunge every Geom found to optimize it for eventual rendering on the indicated GSG.

If there is no GSG indicated for the SceneGraphReducer, this is a no-op.

This operation will also apply to stashed children.

int removeColumn | ( | PandaNode | root,
|  | InternalName const | column
| ) |  |

Removes the indicated data column from any GeomVertexDatas found at the indicated root and below.

Returns the number of GeomNodes modified.

removeUnusedVertices | ( | PandaNode | root | ) |

Removes any vertices in GeomVertexDatas that are no longer used at this level and below.

This requires remapping vertex indices in all of the GeomPrimitives, to remove holes in the GeomVertexDatas. It is normally not necessary to call this explicitly.

setCombineRadius | ( | float | combine_radius | ) |

Specifies the radius that is used in conjunction with CS_within_radius to decide whether a subgraph's siblings should be combined into a single node or not.

If the CS_within_radius bit is included in the combine_siblings_bits parameter passed to flatten, than any nodes whose bounding volume is smaller than the indicated radius will be combined together (as if CS_other were set).

setGsg | ( | GraphicsStateGuardianBase | gsg | ) |

Specifies the particular GraphicsStateGuardian that this object will attempt to optimize to.

The GSG may specify parameters such as maximum number of vertices per vertex data, max number of vertices per primitive, and whether triangle strips are preferred. It also affects the types of vertex column data that is created by premunge().

unify | ( | PandaNode | root,
|  | bool | preserve_order
| ) |  |

Calls unify() on every GeomNode at this level and below.

This attempts to reduce the total number of individual Geoms and GeomPrimitives by combining these objects wherever possible. See GeomNode.unify().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties